// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.faces.context.FacesContext;
import org.apache.commons.lang.ArrayUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.myfaces.tobago.component.MethodBindingToMethodExpression;
import org.apache.myfaces.tobago.component.MethodExpressionToMethodBinding;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.renderkit.MarginValues;
import org.apache.myfaces.tobago.renderkit.SpacingValues;
import org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.ArrayList;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/** 
 Renders a button element.
  * UIComponent class, generated from template {@code component1.2.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.ButtonTagDeclaration}.
 */
public class UIButton
    extends UICommand  {

  public static final String COMPONENT_TYPE = "org.apache.myfaces.tobago.Button";

  private java.lang.Character accessKey;
  private java.lang.String labelWithAccessKey;
  private java.lang.Boolean defaultCommand;
  private java.lang.Integer tabIndex;
  private java.lang.String tip;
  private java.lang.Boolean inline;
  private java.lang.Boolean jsfResource;
  private java.lang.Boolean transition;
  private java.lang.String image;
  private java.lang.String label;
  private java.lang.Boolean immediate;
  private java.lang.Boolean disabled;


  /**
  Deprecated! Has not longer any function.

  @deprecated*/
  @Deprecated
  public java.lang.Character getAccessKey() {
    if (accessKey != null) {
      return accessKey;
    }
    ValueExpression ve = getValueExpression("accessKey");
    if (ve != null) {
      try {
        return (java.lang.Character) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  @Deprecated
  public void setAccessKey(java.lang.Character accessKey) {
    this.accessKey = accessKey;
  }

  /**
  Deprecated! Use 'label' instead.
   Text value to display as label.
   If text contains an underscore the next character overwrites 'accesskey'.

  @deprecated*/
  @Deprecated
  public java.lang.String getLabelWithAccessKey() {
    if (labelWithAccessKey != null) {
      return labelWithAccessKey;
    }
    ValueExpression ve = getValueExpression("labelWithAccessKey");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  @Deprecated
  public void setLabelWithAccessKey(java.lang.String labelWithAccessKey) {
    this.labelWithAccessKey = labelWithAccessKey;
  }

  /**
  If true the command is executed as default -- for example if the
   user presses the enter key inside a related input field.
  <br />Default: <code>false</code>
  */
  public boolean isDefaultCommand() {
    if (defaultCommand != null) {
      return defaultCommand;
    }
    ValueExpression ve = getValueExpression("defaultCommand");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return false;
  }

  public void setDefaultCommand(boolean defaultCommand) {
    this.defaultCommand = defaultCommand;
  }

  /**
  Controls the navigation of the focus through the
   input controls on a page with the Tab-Key.
   The navigation starts from the element with
   the lowest tabIndex value to the element with the highest value.
   Elements that have identical tabIndex values should be navigated
   in the order they appear in the character stream
   Elements that are disabled or with a negative tabIndex
   do not participate in the tabbing order.

  */
  public java.lang.Integer getTabIndex() {
    if (tabIndex != null) {
      return tabIndex;
    }
    ValueExpression ve = getValueExpression("tabIndex");
    if (ve != null) {
      try {
        Number number = (Number) ve.getValue(getFacesContext().getELContext());
        if (number != null) {
          return number.intValue();
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setTabIndex(java.lang.Integer tabIndex) {
    this.tabIndex = tabIndex;
  }

  /**
  Text value to display as tooltip.

  */
  public java.lang.String getTip() {
    if (tip != null) {
      return tip;
    }
    ValueExpression ve = getValueExpression("tip");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setTip(java.lang.String tip) {
    this.tip = tip;
  }

  /**
  Flag indicating this component should rendered as an inline element.
  <br />Default: <code>false</code>
  @deprecated*/
  @Deprecated
  public boolean isInline() {
    if (inline != null) {
      return inline;
    }
    ValueExpression ve = getValueExpression("inline");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return false;
  }

  @Deprecated
  public void setInline(boolean inline) {
      Deprecation.LOG.error("The attribute 'inline' of 'UIButton' is deprecated. "
          + "Please refer the documentation for further information.");
    this.inline = inline;
  }

  /**
  Flag indicating that the resource referenced by the resource attribute is a jsf resource.
   That means that the url has to be processed to change the prefix or suffix (e. g. *.jsf or
   /faces/*). Default is false.
  <br />Default: <code>false</code>
  */
  public boolean isJsfResource() {
    if (jsfResource != null) {
      return jsfResource;
    }
    ValueExpression ve = getValueExpression("jsfResource");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return false;
  }

  public void setJsfResource(boolean jsfResource) {
    this.jsfResource = jsfResource;
  }

  /**
  Specify, if the command calls an JSF-Action.
   Useful to switch off the Double-Submit-Check and Waiting-Behavior.
  <br />Default: <code>true</code>
  */
  public boolean isTransition() {
    if (transition != null) {
      return transition;
    }
    ValueExpression ve = getValueExpression("transition");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return true;
  }

  public void setTransition(boolean transition) {
    this.transition = transition;
  }

  /**
  Url to an image to display.

  */
  public java.lang.String getImage() {
    if (image != null) {
      return image;
    }
    ValueExpression ve = getValueExpression("image");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setImage(java.lang.String image) {
    this.image = image;
  }

  /**
  Text value to display as label.
   If text contains an underscore the next character is used as accesskey.

  */
  public java.lang.String getLabel() {
    if (label != null) {
      return label;
    }
    ValueExpression ve = getValueExpression("label");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setLabel(java.lang.String label) {
    this.label = label;
  }

  /**
  Flag indicating that, if this component is activated by the user,
   notifications should be delivered to interested listeners and actions
   immediately (that is, during Apply Request Values phase) rather than
   waiting until Invoke Application phase.
  <br />Default: <code>false</code>
  */
  public boolean isImmediate() {
    if (immediate != null) {
      return immediate;
    }
    ValueExpression ve = getValueExpression("immediate");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return false;
  }

  public void setImmediate(boolean immediate) {
    this.immediate = immediate;
  }

  /**
  Flag indicating that this element is disabled.
  <br />Default: <code>false</code>
  */
  public boolean isDisabled() {
    if (disabled != null) {
      return disabled;
    }
    ValueExpression ve = getValueExpression("disabled");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return false;
  }

  public void setDisabled(boolean disabled) {
    this.disabled = disabled;
  }

  public void restoreState(FacesContext context, Object componentState) {
    Object[] values = (Object[]) componentState;
    super.restoreState(context, values[0]);
    accessKey = (java.lang.Character) values[1];
    labelWithAccessKey = (java.lang.String) values[2];
    defaultCommand = (java.lang.Boolean) values[3];
    tabIndex = (java.lang.Integer) values[4];
    tip = (java.lang.String) values[5];
    inline = (java.lang.Boolean) values[6];
    jsfResource = (java.lang.Boolean) values[7];
    transition = (java.lang.Boolean) values[8];
    image = (java.lang.String) values[9];
    label = (java.lang.String) values[10];
    immediate = (java.lang.Boolean) values[11];
    disabled = (java.lang.Boolean) values[12];
  }

  public Object saveState(FacesContext context) {
    Object[] values = new Object[13];
    values[0] = super.saveState(context);
    values[1] = accessKey;
    values[2] = labelWithAccessKey;
    values[3] = defaultCommand;
    values[4] = tabIndex;
    values[5] = tip;
    values[6] = inline;
    values[7] = jsfResource;
    values[8] = transition;
    values[9] = image;
    values[10] = label;
    values[11] = immediate;
    values[12] = disabled;
    return values;
  }


}